/*P3-2.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 

#define PI	3.1415926535898
#define	A	1.0					//x1Ƃ
#define	D	2.0e-6				//gUW[mm^2/ms]
#define	a	-0.5
#define	b	0.5	

int main(void) 
{
	char	fo[50];
	int		i, ic, nx;
	double	t, rx, dx, x, cx;
	FILE	*fp;

//
	printf("t [ms] = ");
	scanf("%lf", &t);
	printf("rx [mm] = ");
	scanf("%lf", &rx);
	printf("Number of spatial step = ");
	scanf("%d", &nx);
	dx = 2.0*rx/nx;
	printf("dx [mm] = %.3f\n", dx);
	ic = nx/2;										//SObhʒu

//t@C̃I[v
	sprintf(fo, "kukei_t=%.0f.csv", t);
	printf("Output filename >> %s\n", fo);
	if ((fp = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}

//vZяo
	printf("x [mm]\tC\n");
	fprintf(fp, "x [mm],C\n");
	for (i = 0; i < nx; i++) {
		x = (i-ic)*dx;
		cx = A/2.0*(erf((x-a)/sqrt(4.0*D*t))-erf((x-b)/sqrt(4.0*D*t)));	//(3-16) 
		printf("%.3f\t%.3f\n", x, cx);
		fprintf(fp, "%.3f,%.3f\n", x, cx);
	}

	fclose(fp);
	return 0;
}
