/*P3-7.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 

#define PI		3.1415926535898
#define	A		1.0					//x1Ƃ
#define	myu		0.0					//KEXz̒Sʂ0Ƃ
#define	fwhm	0.3					//FWHM=0.3 [mm]
#define	alpha	2.0*PI				//=2
#define	rx		0.6
#define	nx		120

int main(void)
{
	char	fo[50];
	int		i, ic;
	float	sigma, dx, x, re, im, amp;
	FILE	*fp;

//̊mF
	sigma = fwhm/(2.0*sqrt(2.0*log(2.0)));
	printf(" = %.3f\n", sigma);
	dx = 2.0*rx/nx;
	printf("ԊԊu dx [mm] = %.3f\n", dx);
	ic = nx/2;															//SObhʒu

//t@C̃I[v
	sprintf(fo, "initial_gauss.csv");
	printf("o̓t@C >> %s\n", fo);
	if ((fp = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}

//vZяo
	printf("x [mm]\tRe\tIm\tAmp\n");
	fprintf(fp, "x [mm],Re,Im,Amp\n");
	for (i = 0; i < nx; i++) {
		x = (i-ic)*dx;
		re = A*exp(-(x-myu)*(x-myu)/(2.0*sigma*sigma))*cos(alpha*x);	//(3-40) 
		im = A*exp(-(x-myu)*(x-myu)/(2.0*sigma*sigma))*sin(alpha*x);	//(3-41) 
		amp = sqrt(re*re+im*im);										//x
		printf("%.3f\t%.3f\t%.3f\t%.3f\n", x, re, im, amp);
		fprintf(fp, "%.3f,%.3f,%.3f,%.3f\n", x, re, im, amp);
	}

	fclose(fp);
	return 0;
}
