/*P3-8.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 

#define PI		3.1415926535898
#define	A		1.0					//x1Ƃ
#define	myu		0.0					//KEXz̒S0Ƃ
#define	D		2.0e-6				//gUW[mm^2/ms]
#define	fwhm	0.3
#define	alpha	2.0*PI				//=2
#define	rx		0.6
#define	nx		120

int main(void) 
{
	char	fo[50];
	int		i, ic;
	float	t, sigma, dx, x, k, re, im, amp;
	FILE	*fp;

//
	printf(" t [ms] = ");
	scanf("%f", &t);
	sigma = fwhm/(2.0*sqrt(2.0*log(2.0)));
	printf(" = %.3f\n", sigma);
	dx = 2.0*rx/nx;
	printf("ԊԊu dx [mm] = %.3f\n", dx);
	ic = nx/2;									//SObhʒu

//t@C̃I[v
	sprintf(fo, "gauss_dif_fwhm=%.2f_t=%.0f.csv", fwhm, t);
	printf("o̓t@C >> %s\n", fo);
	if ((fp = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}

//vZяo
	printf("x [mm]\tRe\tIm\tAmp\n");
	fprintf(fp, "x [mm],Re,Im,Amp\n");
	for (i = 0; i < nx; i++) {
		x = (i-ic)*dx;
		k = A*sigma/sqrt(2.0*D*t+sigma*sigma)*exp((-2.0*D*t*sigma*sigma*alpha*alpha-(x-myu)*(x-myu))/(4.0*D*t+2.0*sigma*sigma));	//W
		re = k*cos((2.0*D*t*alpha*myu+alpha*sigma*sigma*x)/(2.0*D*t+sigma*sigma));		//(3-46) 
		im = k*sin((2.0*D*t*alpha*myu+alpha*sigma*sigma*x)/(2.0*D*t+sigma*sigma));		//(3-47) 
		amp = sqrt(re*re+im*im);														//x
		printf("%.3f\t%.3f\t%.3f\t%.3f\n", x, re, im, amp);
		fprintf(fp, "%.3f,%.3f,%.3f,%.3f\n", x, re, im, amp);
	}

	fclose(fp);
	return 0;
}

