/*P4-2.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define	IMG 335
#define D	1.4				//gUW
#define TH	0.0				//MPG̈[degree]
#define NB	4				//_
#define	S0	100.0			//M̏l

void read_data_float(char *, float *, int);		//֐̃vg^Cv錾

int main(void)
{
	FILE	*fp;
	char	fi[100], ft[100];
	int		i, n, P[2] = {0, 1000000}, in_i, in_j, out_i, out_j;
	int		b[4] = {1003, 2005, 2997, 3996};
	float	s_in, s_out;
	float	*img;

	img = (float *)malloc(IMG*IMG*sizeof(float));

//
	in_i = IMG/2;
	in_j = IMG/2;
	out_i = IMG/2;
	out_j = IMG/2-33;

	sprintf(ft, "result.csv");
	if ((fp = fopen(ft, "w")) == NULL) {
		fprintf(stderr, " Error : file open [%s].\n", ft);
		exit(1);
	}

	for (i = 0; i < 2; i++) {
		printf("\nP:%d [m/s] in_i:%d in_j:%d out_i:%d out_j:%d \n\n", P[i], in_i, in_j, out_i, out_j);
		printf("b\tin\tout\tSI(in)\tSI(out)\n");
		fprintf(fp, "\nP:%d [m/s] in_i:%d in_j:%d out_i:%d out_j:%d\n", P[i], in_i, in_j, out_i, out_j);
		fprintf(fp, "b,in,out,SI(in),SI(out)\n");
//b=0
		s_in = S0;
		s_out = S0;
		printf("%d\t%.1f\t%.1f\t%.3f\t%.3f\n", 0, s_in, s_out, log(s_in/S0), log(s_out/S0));
		fprintf(fp, "%d,%.1f,%.1f,%.3f,%.3f\n", 0, s_in, s_out, log(s_in/S0), log(s_out/S0));

//b=1000`4000
		for (n = 0; n < NB; n++) {
			sprintf(fi, "dif_m_De%.1f_Di%.1f_P%d_th%.1f_b%d_2.img", D, D, P[i], TH, b[n]);
			read_data_float(fi, img, IMG*IMG);								//摜̓ǂݏo
			s_in = img[in_i*IMG+in_j];
			s_out = img[out_i*IMG+out_j];
			printf("%d\t%.1f\t%.1f\t%.3f\t%.3f\n", b[n], s_in, s_out, log(s_in/S0), log(s_out/S0));
			fprintf(fp, "%d,%.1f,%.1f,%.3f,%.3f\n", b[n], s_in, s_out, log(s_in/S0), log(s_out/S0));
		}
	}
	fclose(fp);

	return(0);
}

void read_data_float(char *fi, float *img, int size) /*file open and read data*/
{
	FILE *fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}