/* PB-11.c */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#define IMG	256

int Header_Size(char *);							//֐̃vg^Cv錾
void read_data_short(char *, short *, int , int );
void write_data_short(char *, short *, int );

int main(void)
{
	char	fi[50];
	short	*img;
	int		header;

//̊m
	img = (short *)malloc(IMG*IMG*sizeof(short));

	sprintf(fi, "b1000.dcm");
	header = Header_Size(fi);						//wb_[t@C̃TCY̌vZ
	read_data_short(fi, img, IMG*IMG, header);		//DICOMt@C̓ǂݏo
	write_data_short("output.img", img, IMG*IMG);	//摜f[^̏o

	return 0;
}

int Header_Size(char *fi)
{
    struct	stat buf;

    if ((stat(fi, &buf)) != 0) {
		fprintf(stderr, "Error :file open[%s] \n", fi);
        exit(1);
    }
	printf("Size   >> %ld [byte]\n", buf.st_size);
	printf("Header >> %ld [byte]\n", buf.st_size-IMG*IMG*sizeof(short));
    return buf.st_size-IMG*IMG*sizeof(short);
 }

void read_data_short(char *fi, short *in, int size, int header)	/*file open and read data*/
{
	short	*dum;
	FILE	*fp;
	dum = (short *)malloc(header);
	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, "Error :file open[%s] \n", fi);
		exit(1);
	}
	fread(dum, 1, header, fp);
	fread(in, sizeof(short), size, fp);
	fclose(fp);
	printf("read data : %s\n", fi);
	free(dum);
}

void write_data_short(char *fi, short *im, int size)	/*file open and write data*/
{	
	FILE	*fp;
	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, "Error :file open[%s] \n", fi);
		exit(1);
	}
	fwrite(im, sizeof(short), size, fp);
	fclose(fp);
	printf("write data : %s\n", fi);	
}
