/*P3-10.c*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h> 

#define PI		3.1415926535898
#define	A		1.0				//x1Ƃ
#define	myu		0.0				//KEXz̒S0Ƃ
#define	D		2.0e-6			//gUW[mm^2/ms]
#define	fwhm	0.4
#define	alpha	2.0*PI			//=2
#define	gamma	42.58*2.0*PI	//(rad/ms/mT)
#define	G		1.0e-3			//XΎꋭx(mT/mm):̍΍^͎v
#define	rx		0.6
#define	nx		120

int main(void) 
{
	char	fo[50];
	int		i, ic;
	float	t, sigma, dx, x, k, e1, e2, th, re, im, amp;	//k, e1, e2, th͌vZp̕ϐ
	FILE	*fp;

//

//
	printf(" t [ms] = ");
	scanf("%f", &t);
	sigma = fwhm/(2.0*sqrt(2.0*log(2.0)));
	printf(" = %.3f\n", sigma);
	dx = 2.0*rx/nx;
	printf("ԊԊu dx [mm] = %.3f\n", dx);
	ic = nx/2;												//SObhʒu

//t@C̃I[v
	sprintf(fo, "gauss_mpg_fwhm=%.2f_t=%.0f.csv", fwhm, t);
	printf("o̓t@C >> %s\n", fo);
	if ((fp = fopen(fo, "w")) == NULL) {
		fprintf(stderr, "file open error[%s]\n", fo);
		exit(1);
	}

//vZяo
	printf("x [mm]\tRe\tIm\tAmp\n");
	fprintf(fp, "x [mm],Re,Im,Amp\n");
	for (i = 0; i < nx; i++) {
		x = (i-ic)*dx;
		k = A*sigma/sqrt(2.0*D*t+sigma*sigma);												//W
		e1 = -D*gamma*gamma*G*G*t*t*t*(D*t+2.0*sigma*sigma)/(6.0*(2.0*D*t+sigma*sigma));
		e2 = -(2.0*D*t*alpha*sigma*sigma*(alpha-gamma*G*t)+(x-myu)*(x-myu))/(2.0*(2.0*D*t+sigma*sigma));
		th = (x*(-gamma*G*t*(D*t+sigma*sigma)+alpha*sigma*sigma)+D*t*myu*(2.0*alpha-gamma*G*t))/(2.0*D*t+sigma*sigma);
		re = k*exp(e1+e2)*cos(th);															//(3-66) 
		im = k*exp(e1+e2)*sin(th);															//(3-67) 
		amp = sqrt(re*re+im*im);															//x
		printf("%.3f\t%.3f\t%.3f\t%.3f\n", x, re, im, amp);
		fprintf(fp, "%.3f,%.3f,%.3f,%.3f\n", x, re, im, amp);
	}

	fclose(fp);
	return 0;
}
